package processModel;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class State implements Element
{
	
	
	private String label = "";
	protected int id = -1;
	
	private List<Property> properties;
	
	public State()
	{
		properties = new ArrayList<Property>();
		properties.add(new StateProperty("Pressure"));
		properties.add(new StateProperty("Temperature"));
		properties.add(new StateProperty("Volume"));
	}
	
	public List<Property> getProperties()
	{
		return Collections.unmodifiableList(properties);
	}
	
	public List<Property> getCalculatedProperties()
	{
		List<Property> calculatedProperties = new ArrayList<Property>();
		for (Property property : properties)
		{
			if (property.isCalculated()) {
				calculatedProperties.add(property);
			}
		}
		return Collections.unmodifiableList(calculatedProperties); 
	}
	
	public List<Property> getUnknownProperties()
	{
		List<Property> unknownProperties = new ArrayList<Property>();
		for (Property property : properties)
		{
			if (property.isUnknown()) {
				unknownProperties.add(property);
			}
		}
		return Collections.unmodifiableList(unknownProperties); 
	}

	public void label(String l) {
		this.label = l;
	}
	
	public String label(){
		return label;
	}
	
	public int getID ()
	{
		return id;
	}
	
	public void setID(int id)
	{
		this.id = id;
	}
	
	public String toAspireXML()
	{
		return null;
	}
}