/**
 * 
 */
package processModel;

import java.awt.Cursor;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.Line2D;
import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;
import java.util.Observable;
import processView.Externaliser;

import utilities.AppConstants;

/**
 * @author Administrator
 *
 */
public abstract class Transition implements Element, Moveable {

	private String label="";
	private List <TransitionHandle> handles = new ArrayList<TransitionHandle>();
	protected int id = -1;
	
	private List<Property> properties;
	public String name;
	
	public Transition(String name) {
		this.name = name;
		properties = new ArrayList<Property>();
		properties.add(new TransitionProperty("Delta U"));
		properties.add(new TransitionProperty("Work"));
		properties.add(new TransitionProperty("Heat"));
	}
	
	/**
	 * @return true if the receiver is not fully joined to states.
	 */
	public boolean isNotJoined()
	{
		for (TransitionHandle handle : handles) {
			if (!handle.isConnected())
			{
				return true;
			}
		}
		return false;
	}
	
	public String toString() {
		return this.getClass().getCanonicalName() + " labelled " + label;
	}
	
	public List<TransitionHandle> getHandles() {
		return handles;
	}
	
	public  void setHandles(List<TransitionHandle> handles) {
		this.handles = handles;
	}
	
	public void label(String l) {
		label = l;
	}
	
	public int getID ()
	{
		return id;
	}
	
	public void setID(int id)
	{
		this.id = id;
	}
	
	public String label(){return this.label;}
	
	
}
