package processView;

import java.awt.Frame;

import javax.swing.BoxLayout;
import javax.swing.JDialog;
import processModel.Process;

public abstract class DialogMenu extends JDialog {

	private Frame owner;
	private String title;
	private String label ="";
	private String delta = "";
	protected Process process = null;
	
	protected DialogMenu(Frame owner, String title, Process process) {
		super(owner, title, true);
		this.owner = owner;
		this.title = title;
		this.process = process;
		this.getContentPane().setLayout(new BoxLayout(this.getContentPane(), BoxLayout.Y_AXIS));
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.setLocationRelativeTo(owner);
	}

	public void label(String label){
		if (label == null || label == "")
			this.label = process.assignNextLabel();
		else 
			this.label = label.trim();
	}
	
	public void delta(String delta){
		if (delta == null)
			this.delta = "";
		else 
			this.delta = delta.trim();
	}
	
	public String label(){return this.label;}
	public String delta(){return this.delta;}
	public String title(){return this.title;}
	public Frame owner (){return owner;}
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -1752878514152125053L;

	protected abstract void createGUI();
	
}
